#define ON 1
#define OFF 0

#define LED 13

#include <SPI.h>
#include <RF22.h>

// relays pins
//int pinRelays[]={A3,7,A2,6,5,6,A0,4};
int pinRelays[]={A3,7,A2,6,A1,5,A0,4};
uint8_t status_relays[]={0,0,0,0,0,0,0,0};

// Singleton instance of the radio
RF22 rf22;

void(* resetFunc) (void) = 0;

void setup() {
  Serial.begin(9600);
  // pins relay ini
  for(int i=0;i<8;i++) {
    pinMode(pinRelays[i],OUTPUT);
    digitalWrite(pinRelays[i],OFF);
  }
  // пин 13: горит - ok, нет - False
  pinMode(LED,OUTPUT);
  digitalWrite(LED,LOW);
  //
  if (!rf22.init()){
    Serial.println("RF22 init failed");
    digitalWrite(LED,HIGH);
    // перезагрузка
    delay(3000);
    resetFunc();
  }
}

void loop()
{
  while (1)
  {
    rf22.waitAvailable();
    //Serial.println(millis());
    // Should be a message for us now   
    //uint8_t buf[RF22_MAX_MESSAGE_LEN];
    uint8_t buf[9];
    uint8_t len = sizeof(buf);
    if (rf22.recv(buf, &len))
    {
      Serial.println("got request: ");
      Serial.println((char*)buf);

      // relay 
      for(int i=7;i>=0;i--){
         status_relays[i]=buf[7-i]-48;
         Serial.print(status_relays[i]);
      }
      // включение/выключение 
      for(int i=0;i<8;i++){
         if(status_relays[i]==1)
          digitalWrite(pinRelays[i],ON);
         else
          digitalWrite(pinRelays[i],OFF);
          Serial.print("pinRelay ");Serial.print(pinRelays[i]);Serial.print("=");Serial.println(status_relays[i]);
      }
      //delay(500);      
      // Send a reply
      uint8_t data[9]={0,0,0,0,0,0,0,0,0};
      for(int i=0;i<8;i++) {
         data[i]=status_relays[i]+48;      
      }
      rf22.send(data, sizeof(data));
      rf22.waitPacketSent();
      Serial.println("Sent a reply");
    }
    else
    {
      Serial.println("recv failed");
    }
  }
}
